function gui(obj) %#ok<*INUSD>
%gui The beginnings of a GUI for dealing with PSF data.

xsz=400;
ysz=500;
xst=100;
yst=100;
pw=.95;
psep=.01;
staticst=5;
editst=110;
global fullFileName;
global textTwo;
global textTwelve;


h.fig = figure('Units','pixels','position', [xst yst xsz ysz],...
    'MenuBar','none','ToolBar','none','Visible','on',...
 'NumberTitle','off',...
    'name','Data Analysis.gui');

defaultBackground = get(0,'defaultUicontrolBackgroundColor');
set(h.fig,'Color',defaultBackground);
handles.output = h.fig;
guidata(h.fig,handles);

refh=1;

ph=0.09;
php = ph*ysz;

%Position syntax: [left bottom width height]


%File and data panel
hp = uipanel('Title','Data','FontSize',12,...
             'Position',[.05 .6 .4 .3]);
%Microscope panel
mp = uipanel('Title','Microscope','FontSize',12,...
             'Position',[.05 .25 .35 .3]);
%Phase retrieval panel
rp = uipanel('Title','Phase Retrieval','FontSize',12,...
             'Position',[.05 .25 .35 .3]);
%Display panel
dp = uipanel('Title','Display','FontSize',12,...
             'Position',[.6 .6 .35 .4]);
%Save panel
sp = uipanel('Title','Save','FontSize',12,...
             'Position',[.6 .25 .35 .3]);
        
         
         
 buttonZero = uicontrol('Parent', hp, 'Style','pushbutton',...
        'Position',[staticst 100 20 20],...
        'String','File');
    set(buttonZero, 'callback', @fileGet)
     textTwo = uicontrol('Parent', hp, 'Style','edit',... 
     'Position',[staticst+30 100 60 20],...
     'String','');
 
  h.buttonOne = uicontrol('Parent',hp, 'style', 'pushbutton' ,...
    'position', [staticst+100 100 40 20] ,... 
    'string' , 'Load');
 
    
    function fileGet(~,~)
        delete(textTwo)
        [baseName, folder] = uigetfile();
        fullFileName = fullfile(folder, baseName);
         textTwo = uicontrol('Parent', hp, 'Style','edit',... 
     'Position',[staticst+20 100 60 20],...
     'String','');
        set(textTwo,'String',fullFileName);
    end

    function loadData(~,~) %#ok<*DEFNU>
        %Reserved for loading data via "Load" pushbutton
    end

  dataName = uicontrol('Parent', hp, 'Style','text',...
        'Position',[staticst 60 60 20],...
        'String','Data Name');
    
    textThree = uicontrol('Parent', hp, 'Style','edit',... 
     'Position',[staticst+60 60 60 20],...
     'String','');
 
   zVector = uicontrol('Parent', hp, 'Style','text',...
        'Position',[staticst 40 60 20],...
        'String','Z-Vector');
  
  textFour = uicontrol('Parent',hp, 'Style','edit',... 
     'Position',[staticst+60 40 60 20],...
     'String','');
 
   center = uicontrol('Parent', hp, 'Style','text',...
        'Position',[staticst 40 60 20],...
        'String','Center');
 
    textFive = uicontrol('Parent',hp, 'Style','edit',... 
     'Position',[staticst+60 40 60 20],...
     'String','');
 
    na = uicontrol('Parent',mp, 'Style','text',...
        'Position',[staticst-25 110 60 20],...
        'String','NA');

    textSix = uicontrol('Parent',mp, 'Style','edit',... 
     'Position',[staticst+70 110 60 20],...
     'String','');
 
  waveLength = uicontrol('Parent',mp, 'Style','text',...
        'Position',[staticst-5 90 60 20],...
        'String','Wavelength');
    
       textSeven = uicontrol('Parent',mp, 'Style','edit',... 
     'Position',[staticst+70 90 60 20],...
     'String','');
 
   indexOfRefraction = uicontrol('Parent',mp, 'Style','text',...
        'Position',[staticst-20 70 60 20],...
        'String','Index');
    
           textEight = uicontrol('Parent',mp, 'Style','edit',... 
     'Position',[staticst+70 70 60 20],...
     'String','');
    
       pixelSize = uicontrol('Parent',mp, 'Style','text',...
        'Position',[staticst-10 50 60 20],...
        'String','Pixel Size');
    
           textNine = uicontrol('Parent',mp, 'Style','edit',... 
     'Position',[staticst+70 50 60 20],...
     'String','');
 
   maxZernike = uicontrol('Parent', rp, 'Style','text',...
        'Position',[staticst-10 100 100 20],...
        'String','Mag. Max Zernike');
    
           textTen = uicontrol('Parent',rp, 'Style','edit',... 
     'Position',[staticst+90 100 40 20],...
     'String','');
 
   phaseZernike = uicontrol('Parent', rp, 'Style','text',...
        'Position',[staticst-8 80 100 20],...
        'String','Phase Max Zernike');
      textEleven = uicontrol('Parent',rp, 'Style','edit',... 
     'Position',[staticst+90 80 40 20],...
     'String','');
 
   h.buttonTwo = uicontrol('Parent',rp, 'style', 'pushbutton' ,...
    'position', [staticst+23 40 80 20] ,... 
    'string' , 'Phase Retrieve');


checkbox = uicontrol('Parent', dp, 'Style','Checkbox','Units','Pixels',...
                'Position',[staticst 140 100 50], 'String', 'Linear Display'); %#ok<*NASGU>
            
    h.buttonThree = uicontrol('Parent',dp, 'style', 'pushbutton' ,...
    'position', [staticst 120 100 20] ,... 
    'string' , 'Show Pupil Mag.');

    h.buttonFour = uicontrol('Parent',dp, 'style', 'pushbutton' ,...
    'position', [staticst 100 110 20] ,... 
    'string' , 'Show Pupil Phase');

    h.buttonFive = uicontrol('Parent',dp, 'style', 'pushbutton' ,...
    'position', [staticst 80 80 20] ,... 
    'string' , 'Show Data');

    h.buttonSix = uicontrol('Parent',dp, 'style', 'pushbutton' ,...
    'position', [staticst 60 100 20] ,... 
    'string' , 'Plot Zernike');

    h.buttonSeven = uicontrol('Parent',dp, 'style', 'pushbutton' ,...
    'position', [staticst 40 100 20] ,... 
    'string' , 'Show Overlay');

    h.buttonEight = uicontrol('Parent',dp, 'style', 'pushbutton' ,...
    'position', [staticst 20 80 20] ,... 
    'string' , 'Show Model');

    buttonNine = uicontrol('Parent',sp, 'style', 'pushbutton' ,...
    'position', [staticst 100 80 20] ,... 
    'string' , 'Select File');
 set(buttonNine, 'callback', @fileGetII)

      textTwelve = uicontrol('Parent',sp, 'Style','edit',... 
     'Position',[staticst 70 80 20],...
     'String','');
 
     h.buttonTen = uicontrol('Parent',sp, 'style', 'pushbutton' ,...
    'position', [staticst 40 80 20] ,... 
    'string' , 'Save File');
 

    function fileGetII(~,~)
                delete(textTwelve)
        [baseName, folder] = uiputfile();
        fullFileName = fullfile(folder, baseName);
      textTwelve = uicontrol('Parent',sp, 'Style','edit',... 
     'Position',[staticst 70 80 20],...
     'String','');
        set(textTwelve,'String',fullFileName);
    end

    function fileSave(~,~)
        %Reserved for saving data via "Save file" pushbutton
    end

            %set(checkbox1, 'callback', {@isChecked})
            
    %function isChecked(checkbox1, value, testTxt)
            %value = get(checkbox1, 'Value');
                        %testTxt = uicontrol('Style','text',...
        %'Position',[200 700 60 50],...
        %'String','Testing');
            %if value
                %Checkbox is checked
                 %set(testTxt, 'Visible', 'on')
            %else
                %Checkbox is unchecked
                 %set(testTxt, 'Visible', 'off')
            %end
          
end
    
